/**
 * @import {} from 'mdast-util-directive'
 * @import {Root} from 'mdast'
 * @import {} from 'remark-arse'
 * @import {} from 'remark-stringify'
 * @import {Processor} from 'unified'
 */

import {
	directiveFromMarkdown,
	directiveToMarkdown,
} from "mdast-util-directive";
import { directive } from "micromark-extension-directive";

/**
 * Add support for generic directives.
 *
 * ###### Notes
 *
 * Doesn’t handle the directives: create your own plugin to do that.
 *
 * @returns {undefined}
 *   Nothing.
 */
export default function remarkDirective() {
	const data = this.data();

	const micromarkExtensions =
		data.micromarkExtensions || (data.micromarkExtensions = []);
	const fromMarkdownExtensions =
		data.fromMarkdownExtensions || (data.fromMarkdownExtensions = []);
	const toMarkdownExtensions =
		data.toMarkdownExtensions || (data.toMarkdownExtensions = []);

	micromarkExtensions.push(directive());
	fromMarkdownExtensions.push(directiveFromMarkdown());
	toMarkdownExtensions.push(directiveToMarkdown());
}
